package org.josast.ApplicationSatelliteDatabaseCli.cmd;

import java.io.File;
import java.util.logging.Logger;

import org.josast.ModuleSatelliteDatabase.UpdateAmsatListFile;

public class UpdateCmd implements Cmd {

	private Logger log = Logger.getLogger(getClass().getName());

	@Override
	public void excute() {
		ParameterSingleton parameter = ParameterSingleton.getInstance();
		String inputRepository = parameter.getInputDirectory();
		String outputRepository = parameter.getOutputDirectory();
		File inputRepertoire = new File(inputRepository);
		File outputRepertoire = new File (outputRepository);
		
		int i = 0;
		if (inputRepertoire.isDirectory() == false) {
			log.severe(inputRepository+"is not a repository");
//			System.err.println("not a repository");
//			return -1;
		}
		if (outputRepertoire.exists() == false) {
			log.info("create "+ inputRepository);
			if (!outputRepertoire.mkdir())
			{
				log.severe(outputRepertoire+"is not created");
			}
			
//			System.err.println("not a repository");
//			return -1;
		} else if (outputRepertoire.isDirectory() == false) {
			log.severe(outputRepertoire+"is not a repository");
//			System.err.println("not a repository");
//			return -1;
		}
			
		
		File[] inputsfiles = inputRepertoire.listFiles();
		if (inputsfiles == null) {
			log.severe(inputRepository+"Repository empty");
//			System.err.println("Repository empty");
//			return -1;
		} else {
			for (i = 0; i < inputsfiles.length; i++) {
				
				UpdateAmsatListFile up = new UpdateAmsatListFile(inputsfiles[i].getAbsolutePath());
				up.updateStatus();
				up.saveUpdateFile(outputRepository+"\\"+inputsfiles[i].getName());
//				System.out.println(inputsfiles[i]);
//				appendSatellites(inputsfiles[i]);
			}
		}

		
	}
	

}
