package org.josast.ModuleSatelliteDatabase;

import java.util.Hashtable;
import java.util.List;
import java.util.ListIterator;
import java.util.Vector;

import org.josast.AmsatList.generated.AmsatList;
import org.josast.AmsatList.generated.Satellites;

public class CheckAmsatListFile {
	AmsatList al =null;
	
	public CheckAmsatListFile(String file)
	{
		AmsatListFile alf = new AmsatListFile();
		al = alf.openAmsatList(file);
		
		
	}
	
	
	public Vector<String>  checkUniqueSatelliteName()
	{
		
		Hashtable<String, Satellites> AMSATListSatellite = new Hashtable<String, Satellites>();
		
		List<Satellites> listSatellite = al.getSatellites();
		ListIterator<Satellites> it = listSatellite.listIterator();
		Vector<String> satNameVec = new Vector<String>();
		// vérifier qu'un satellite n'est pas deux fois dans la base 
		
		while (it.hasNext()) {
			Satellites sat = it.next();
			String satelliteName = sat.getName();
			
			if (AMSATListSatellite.containsKey(satelliteName) == true) {
				satNameVec.addElement(satelliteName);
			}else
			{
				AMSATListSatellite.put(satelliteName, sat);
			}
		

		
	}
		return satNameVec;
	}
	
	public Vector<String>  checkUniqueSatelliteNasaID()
	{
		
		Hashtable<Integer, Satellites> AMSATListSatellite = new Hashtable<Integer, Satellites>();
		
		List<Satellites> listSatellite = al.getSatellites();
		ListIterator<Satellites> it = listSatellite.listIterator();
		Vector<String> satNameVec = new Vector<String>();
		// vérifier qu'un satellite n'est pas deux fois dans la base 
		
		while (it.hasNext()) {
			Satellites sat = it.next();
			int satelliteId = sat.getNasaID();
			
			if (AMSATListSatellite.containsKey(satelliteId) == true) {
				satNameVec.addElement(sat.getName()+ " "+satelliteId);
			}else
			{
				AMSATListSatellite.put(satelliteId, sat);
			}
		
	}
		return satNameVec;
	}
	
	
	public  Vector<String> getListSatelliteStatus ()
	{
		Hashtable<String, Vector<Satellites>> AMSATListStatus = new Hashtable<String, Vector<Satellites>>();
		
		List<Satellites> listSatellite = al.getSatellites();
		Vector<String> satelliteStatus = new Vector<String>();

		ListIterator<Satellites> it = listSatellite.listIterator();
		while (it.hasNext()) {
			Satellites sat = it.next();
			String status = sat.getStatus();
			
			if (status == null)
			{
				System.out.println("Status Null");
				status="Not Defined";
				
			}
			Vector<Satellites> vsat;
			if (AMSATListStatus.containsKey(status) == true) {
				vsat = AMSATListStatus.get(status);
				
			}else
			{
				vsat = new Vector<Satellites>();
				AMSATListStatus.put(status, vsat);
				satelliteStatus.add(status);
			}
			vsat.addElement(sat);
			}
		
		return satelliteStatus;
	}

}
