package org.josast.ModuleSatelliteDatabase;

import java.util.Hashtable;
import java.util.List;
import java.util.ListIterator;


import org.josast.AmsatList.generated.AmsatList;
import org.josast.AmsatList.generated.Satellites;

public class UpdateAmsatListFile {
	
	
	private AmsatList al;
	AmsatListFile alf = null;
	public UpdateAmsatListFile(String filein)
	{
		alf = new AmsatListFile();
		al = alf.openAmsatList(filein);
	}
	
	public void saveUpdateFile (String filename )
	{
		alf.save(filename,al);
	}
	
	public void updateStatus()
	{
		Hashtable<String, String> AMSATListStatus = new Hashtable<String, String>();
		// init table status

		AMSATListStatus.put("decayed ","Decayed");
		AMSATListStatus.put("Decayed ","Decayed");
		AMSATListStatus.put("Deep Space","Deep Space");
		AMSATListStatus.put("Deep space","Deep Space");
		AMSATListStatus.put("Fail","Failed");
		AMSATListStatus.put("Failed","Failed");
		AMSATListStatus.put("Launch","Launch");
		AMSATListStatus.put("No operational","Not operational");
		AMSATListStatus.put("No operational","Not operational");
		AMSATListStatus.put("Not amateur Satellite","Not amateur satellite");
		AMSATListStatus.put("Unknown","Unknown");
		AMSATListStatus.put("Not operational","Not operational");
		AMSATListStatus.put("Not Operational","Not operational");
		AMSATListStatus.put("Operational","Operational");
		AMSATListStatus.put("Operationnal","Operational");
		AMSATListStatus.put("To be deployed","To be deployed");
		AMSATListStatus.put("To Be Laucnh","To be launch");
		AMSATListStatus.put("To Be Launch","To be launch");
		AMSATListStatus.put("To be launched","To be launch");
		AMSATListStatus.put("To be Launched	","To be launch");
		AMSATListStatus.put("unknown","Unknown");
		AMSATListStatus.put("Unknown","Unknown");
		
		List<Satellites> listSatellite = al.getSatellites();

		ListIterator<Satellites> it = listSatellite.listIterator();
		while (it.hasNext()) {
			Satellites sat = it.next();
			String status = sat.getStatus();
			System.out.println(sat.getName()+" "+status);
			if (status == null)
			{
				sat.setStatus("Unknown");
				System.out.println("add status to  :"+ 	sat.getStatus());
				
			}
			else
			{
				status = status.trim();

				if (AMSATListStatus.containsKey(status) == true)
				{
					String refstatus = AMSATListStatus.get(status);
					
					if (refstatus.compareTo(status)!=0)
					{
						sat.setStatus(refstatus);
						System.out.println("Status change :"+status+"to"+refstatus);
					}
				}
				else
				{
					sat.setStatus("Unknown");
					System.out.println("add status to empty  :"+ 	sat.getStatus());
				}
			}
		}
		
	}
	

	
}
