package org.josast.ApplicationSatelliteDatabaseCli.cmd;

import org.apache.commons.cli.Options;

public class ParameterSingleton {
	
	private static ParameterSingleton INSTANCE;

	private String OutputFile;
	private String InputFile;
	private String inputDirectory;
	private String outputDirectory;


	private String arg0;
	private Options option;
	
	     
	    private ParameterSingleton() {        
	    }
	     
	    public static ParameterSingleton getInstance() {
	        if(INSTANCE == null) {
	            INSTANCE = new ParameterSingleton();
	        }
	         
	        return INSTANCE;
	    }
		 
	    // getters and setters	 
	    


		public String getOutputFile() {
			return OutputFile;
		}

		public String getInputDirectory() {
			return inputDirectory;
		}

		public void setInputDirectory(String inputDirectory) {
			this.inputDirectory = inputDirectory;
		}

		public String getOutputDirectory() {
			return outputDirectory;
		}

		public void setOutputDirectory(String outputDirectory) {
			this.outputDirectory = outputDirectory;
		}

		public void setOutputFile(String outputFile) {
			OutputFile = outputFile;
		}

		public String getArg0() {
			return arg0;
		}

		public void setArg0(String arg0) {
			this.arg0 = arg0;
		}

		public Options getOption() {
			return option;
		}

		public void setOption(Options option) {
			this.option = option;
		}

		public void setInputFile(String optionValue) {
			InputFile = optionValue;
			
		}
		public String getInputFile() {
			return InputFile;
		}


	

}
